/*
 *  Revision 20180307, Kai Peter
 *  - added prototypes 'str_cats()' and 'str_copys()'
 *  Revision 20180221, Kai Peter
 *  - adjusted declarations, renamed 'str_start' --> 'str_pcmp'
 *  Revision 20170501, Kai Peter
 *  - added '*str_append' and 'str_cat'
*/
#ifndef STR_H
#define STR_H

#include "byte.h"
#include "stralloc.h"

extern size_t str_copy(char *dst, const char *src);

extern size_t str_diff(char *s, char *t);
#define str_diffn(s,t,n) byte_diff((s),(n),(t))
#define str_equal(s,t) (!str_diff((s),(t)))

extern size_t str_len(const char *s);
extern size_t str_chr(char *s, char c);
extern size_t str_rchr(char *s, char c);
extern size_t str_pcmp(char *s, char *t);

extern ssize_t str_cats(char **dst, char *src);
#define str_copys(dst,src) ((*dst = ""), (str_cats(dst,src)))

#endif
